
// SlaveAcceptorDlg.cpp : implementation file
//-------------------------------------------
#include "stdafx.h"
#include "SlaveAcceptor.h"
#include "SlaveAcceptorDlg.h"
#include "MDBEngine.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CAboutDlg dialog used for App About
//------------------------------------

class CAboutDlg : public CDialog
//==============================
{
public:
	CAboutDlg();
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
//==============================================
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
//================================================
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CSlaveAcceptorDlg dialog
//-------------------------

CSlaveAcceptorDlg::CSlaveAcceptorDlg(CWnd* pParent)	: CDialog(CSlaveAcceptorDlg::IDD, pParent)
//============================================================================================
{
	//{{AFX_DATA_INIT(CSlaveAcceptorDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSlaveAcceptorDlg::DoDataExchange(CDataExchange* pDX)
//========================================================
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSlaveAcceptorDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSlaveAcceptorDlg, CDialog)
	//{{AFX_MSG_MAP(CSlaveAcceptorDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_RESET, OnReset)
	ON_BN_CLICKED(IDC_REJECT, OnReject)
	ON_BN_CLICKED(IDC_COIN_1, OnCoin1)
	ON_BN_CLICKED(IDC_COIN_2, OnCoin2)
	ON_BN_CLICKED(IDC_COIN_3, OnCoin3)
	ON_BN_CLICKED(IDC_COIN_4, OnCoin4)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CSlaveAcceptorDlg message handlers
//-----------------------------------

BOOL CSlaveAcceptorDlg::OnInitDialog()
//====================================
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog. The framework does this automatically
	// when the application's main window is not a dialog
	//--------------------------------------------------------------------
	SetIcon(m_hIcon,TRUE); // Set big icon
	SetIcon(m_hIcon,FALSE);	// Set small icon

	// Initialize MDB engine
	//----------------------
	SLAVE_ACCEPTOR_SETUP Setup;
	memset(&Setup,0,sizeof(SLAVE_ACCEPTOR_SETUP));
	Setup.lParam=(LPARAM)this;
	Setup.hParent=m_hWnd;
	Setup.dwFeatureLevel=2;
	Setup.dwCurrencyCode=0x1978;
	Setup.dwScalingFactor=1;
	Setup.dwDecimalPlaces=2;
	Setup.dwCoinTypeRouting=0x000F;
	Setup.CoinTypeCredit[0]=10;
	Setup.CoinTypeCredit[1]=20;
	Setup.CoinTypeCredit[2]=50;
	Setup.CoinTypeCredit[3]=100;
	if (!MasterAcceptorCreate(&Setup))
	{
		TRACE(_T("Failed to create reader\r\n"));
	}

	// TODO: Add extra initialization here
	//------------------------------------
	return TRUE; // return TRUE unless you set the focus to a control
}

void CSlaveAcceptorDlg::OnSysCommand(UINT nID, LPARAM lParam)
//===========================================================
{
	if ((nID&0xFFF0)==IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID,lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
// to draw the icon. For MFC applications using the document/view model,
// this is automatically done for you by the framework.
//--------------------------------------------------------------------------

void CSlaveAcceptorDlg::OnPaint() 
//===============================
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		//--------------------------------
		int cxIcon=GetSystemMetrics(SM_CXICON);
		int cyIcon=GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x=(rect.Width()-cxIcon+1)/2;
		int y=(rect.Height()-cyIcon+1)/2;

		// Draw the icon
		//--------------
		dc.DrawIcon(x,y,m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display
// while the user drags the minimized window.
//------------------------------------------------------

HCURSOR CSlaveAcceptorDlg::OnQueryDragIcon()
//==========================================
{
	return (HCURSOR)m_hIcon;
}

void CSlaveAcceptorDlg::OnDestroy() 
//=================================
{
	if (!MasterAcceptorDestroy())
	{
		TRACE(_T("Failed to destroy reader\r\n"));
	}
	CDialog::OnDestroy();
}

void CSlaveAcceptorDlg::OnReset() 
//===============================
{
	MasterAcceptorReset();
}

void CSlaveAcceptorDlg::OnReject() 
//================================
{
	;	
}

void CSlaveAcceptorDlg::OnCoin1() 
//===============================
{
	MasterAcceptorDeposit(0,0);
}

void CSlaveAcceptorDlg::OnCoin2() 
//===============================
{
	MasterAcceptorDeposit(0,1);
}

void CSlaveAcceptorDlg::OnCoin3() 
//===============================
{
	MasterAcceptorDeposit(0,2);
}

void CSlaveAcceptorDlg::OnCoin4()
//=============================== 
{
	MasterAcceptorDeposit(0,3);
}
